<template>
	<div>
		<div class="flex flex-wrap account-preview justify-center" v-if="props.bank_accounts.length > 1">
			<bank-account-preview
				v-for="(account, i) in props.bank_accounts"
				:key="i"
				:account="account"
				:selectedAccount="selectedBankAccount"
				@accountSelected="accountSelection"
			/>
		</div>
		<div class="flex flex-wrap account-preview justify-center" v-if="!props.bank_accounts.length">
			<p>{{ __("Please add at least one company bank account. 'Is company account' must be checked.") }}</p>
		</div>
		<file-uploader
			v-show="!showData && (selectedBankAccount || props.bank_accounts.length == 1) && props.upload_type!='plaid'"
			:on_success="onSuccess"
			:allow_multiple="false"
			:method="method"
		/>
		<div class="transactions-table">
			<div ref="datatable"></div>
		</div>
		<div v-show="submitted" class="flex flex-wrap info-section justify-center align-center">
			<div class="text-muted">
				<div v-show="show_spinner.value" class="text-center"><i class="fas fa-spinner fa-spin fa-2x"></i></div>
				<p v-html="text_msg"></p>
			</div>
		</div>
	</div>
</template>

<script setup>
import FileUploader from '../../../../../../frappe/frappe/public/js/frappe/file_uploader/FileUploader.vue';
import BankAccountPreview from './BankAccountPreview.vue';
import { TabulatorFull as Tabulator } from 'tabulator-tables';

import {ref} from 'vue'

const props = defineProps({
	upload_type: {
		type: String,
		default: 'csv'
	},
	bank_accounts: {
		type: Array,
		default: () => []
	}
})

const datatable = ref(null);
const tabulator = ref(null);
const tableData = ref([]);

let columns = []
const method = props.upload_type === 'ofx' ? 'erpnext.accounts.doctype.bank_transaction.bank_transaction_upload.upload_ofx_bank_statement'
			: 'erpnext.accounts.doctype.bank_transaction.bank_transaction_upload.upload_csv_bank_statement'
const showData = ref(false)
const selectedBankAccount = ref(null)
const submitted = ref(false)
const show_spinner = ref(true)
let text_msg = __("Bank transactions creation in progress. Please wait...")

function onSuccess(attachment, r) {
	if (!r.exc && r.message) {
		columns = r.message.columns;
		tableData.value = r.message.data;
		showData.value = true;

		const credit_card_entries = tableData.value.filter(f => f.statement == "Credit Card")
		if (credit_card_entries) {
			erpnext.bank_transaction.trigger('add_credit_card', credit_card_entries.length);
		}
		erpnext.bank_transaction.trigger('add_primary_action');

		tabulator.value = new Tabulator(datatable.value, {
			data: tableData.value,
			autoColumns:true,
			selectable: true,
		});
	}
}

function addBankEntries(include_credit_cards) {
	if (!submitted.value) {
		frappe.xcall('erpnext.accounts.doctype.bank_transaction.bank_transaction_upload.create_bank_entries',
			{
				columns: columns,
				data: include_credit_cards ? tableData.value : tableData.value.filter(f => f.statement != "Credit Card"),
				bank_account: selectedBankAccount.value || props.bank_accounts[0].name,
				upload_type: props.upload_type
			}
		).then((result) => {
			if (result.status == "Missing header map") {
				show_spinner.value = false
				const bank_account = props.bank_accounts.filter(f => f.name == (selectedBankAccount.value || props.bank_accounts[0].name))
				text_msg = __("Please setup a <a href='{0}'>header mapping for this bank</a> before uploading a csv/xlsx file.", [
					frappe.utils.escape_html("/app/bank/" + bank_account[0].bank)
				])
			} else {
				if (result.success !== 0) {
					frappe.show_alert({message:__("All bank transactions have been created"), indicator:'green'});
				}
				if (result.errors !== 0) {
					frappe.show_alert({message:__("Please check the error log for details about the import errors"), indicator:'red'});
				}
				if (result.duplicates !== 0) {
					const message = __("{0} entries are duplicates and have not been created", [result.duplicates])
					frappe.show_alert({message, indicator:'orange'});
				}
				erpnext.bank_transaction.trigger('close_dialog');
				erpnext.bank_reconciliation.trigger("refresh")
			}
		})
	}
}

function accountSelection(account) {
	selectedBankAccount.value = account;

	if (props.upload_type == 'plaid') {
		erpnext.bank_transaction.trigger('add_plaid_action');
	}
}

function syncPlaidTransactions() {
	const bank_account = props.bank_accounts.filter(f => f.name == (selectedBankAccount.value || props.bank_accounts[0].name))
	frappe.xcall('erpnext.erpnext_integrations.doctype.plaid_settings.plaid_settings.sync_transactions', {
		bank: bank_account[0].bank,
		bank_account: bank_account[0].name
	})
	.then((result) => {
		if (!result || result.exc) {
			show_spinner.value = false
			text_msg = __(`Please <a href="/app/plaid-settings">link your bank account with Plaid first</a>`)
		} else {
			const msg1 = __("Bank account '{0}' has been synchronized", [bank_account[0].account_name]);
			const msg2 = __("{0} bank transaction(s) created", [result.length]);
			frappe.show_alert({message:msg1, indicator:'green'});
			frappe.show_alert({message:msg2, indicator:'green'});
			erpnext.bank_transaction.trigger('close_dialog');
			erpnext.bank_reconciliation.trigger("refresh")
		}
	})
}

erpnext.bank_transaction.on('add_bank_entries', (include_credit_cards) => {
	addBankEntries(include_credit_cards)
	submitted.value = true;
})

erpnext.bank_transaction.on('synchronize_via_plaid', () => {
	syncPlaidTransactions()
	submitted.value = true;
})


</script>

<style lang='scss'>
.account-preview {
	margin-bottom: 20px;
}

.info-section {
	min-height: 200px;

	a {
		color: #6195FF;
	}
}
</style>
